#!/usr/bin/perl
# Simple finger daemon
use IO::Socket;

$\="\r\n"; # output line delimiter

# listen on the well-known smtp port
my $port = 1110;

$cfgfile    = 'ano.cfg';				# config filename
$DATAPATH   = '';						# path to data (relative to this script)
$hdrsize    = 9;

# create a server socket to listen for
# connections
$sock = new IO::Socket::INET (LocalPort => $port,
                       Proto => 'tcp',
                              Listen => 5,
                              Reuse => 1) ||
     die "Socket error:  $!\n" unless $sock;

print "POP3 server started. Accepting these profiles:\n";

# first of all, check the profiles
open (in, "<$cfgfile");
while (<in>) {
	if ($_ =~ /^profile=(.*)/i) {
		push (@profiles, $1);
	}
}
close (in);

foreach $profile (@profiles) {
	print "$profile";
}

# listen for connections
# don't disconnect after the first connection
# just keep listening

$i=1;
while ($i) {
print "\nListening...\n";

# new connection accepted
  $new_sock = $sock->accept();

# get the IP of the client, and the hostname
  $ip = $new_sock->peerhost();
  ($name,$alias,$addrtype,$length,$new_addr) =
      gethostbyaddr(inet_aton($ip),AF_INET);

# print the hostname and IP to the screen
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
  print "*****************************************************************";
  print "[$mday-",$mon+1,"-",1900+$year," $hour:$min:$sec] Connection from:  $name [$ip]\n";
  print $new_sock "+OK MalaPOP3 server ready";

  # get the query from the client and display it

parse_command: while (<$new_sock>) {
    chop; chop;
	print $_;
	/^USER *(.*)/i && do {
		$user=$1;
		foreach $profile (@profiles) {
			if ($profile =~ /^$user$/i) {
				open (in, "<$cfgfile");
				while (<in>) {
					if ($_ =~ /^$profile-datafname=(.*)/i) {
						$DATAFNAME=$1;
						print $new_sock "+OK $user... happy to see you";
						next parse_command;
					}
				}
				close (in);
			}
		}
		print $new_sock "-ERR Invalid user $user";
		next parse_command;
	};
	/^PASS *(.*)/i && do {
		$pass=$1;
		print $new_sock "+OK maildrop locked and ready";
		next parse_command;
	};
	/^STAT/i && do {
		stat_function();
		next parse_command;
	};
	/^LIST *(.*)/i && do {
		$msgnum=$1;
		if ($msgnum) {	
		#here you have to put the code for the LIST msgnum command
			list_function ($msgnum,1);
		}
		else {			
		#here you have to put the code for the bare LIST command
			listall_function();
		}
		next parse_command;
	};
	/^RETR *(.*)/i && do {
		$msgnum=$1;
		if ($msgnum) {	#here you have to put the code for the RETR msgnum command
			retr_function($msgnum);
		}
		else {			#here you have to put the code for the bare RETR command
			print $new_sock "+ERR need message number";
		}
		next parse_command;
	};
	/^TOP *(.*)/i && do {
		($msgnum, $lines)=split(/ /,$1);
		if ($msgnum) {	
		#here you have to put the code for the TOP msgnum command
			top_function($msgnum,$lines);
		}
		else {
		#here you have to put the code for the wrong TOP command
			print $new_sock "-ERR wrong syntax";
		}
		next parse_command;
	};
	/^DELE *(.*)/i && do {
		unlink (msgfile($1));
		print $new_sock "+OK";
		next parse_command;
	};
	/^NOOP/ && do {
		print $new_sock "+OK";
		next parse_command;
	};
	/^RSET/i && do {
		#here comes the code to undelete messages
		print $new_sock '+OK maildrop has n messages';
		next parse_command;
	};
	/^QUIT/i && do {
		print $new_sock "+OK MalaPOP3 server signing off";
		close ($new_sock);
		last;
	};
    print $new_sock "-ERR command unrecognized";
};  # end of "while new_sock"

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
print "\n[$mday-",$mon+1,"-",1900+$year," $hour:$min:$sec] $name [$ip] disconnected.";
print "*****************************************************************\n";
};  # end of "while $i"


	
#---------------------------------------------------------------
# listall_function 
#---------------------------------------------------------------

sub listall_function{
	my @messages=();
 	my $here=$DATAPATH?$DATAPATH:'.';
 	$DATAFNAME=~/^(.*)(\.\w+)$/;
 	my ($prefix,$suffix)=($1,$2);

 	if (opendir DATADIR, $here){
  		@messages = sort grep/^$prefix\d\d\d$suffix$/, readdir DATADIR;
  		closedir DATADIR
	}
	$msgcount=0;
	
	if (@messages) {
		print $new_sock "+OK scan listing follows";
  		foreach $message (@messages){
			$msgcount++;
  		}
		for ($j=1;$j<=$msgcount;$j++){
		    list_function($j,0);
		}
		print $new_sock '.';
	}
	else {
	    print $new_sock "-ERR no messages";
	}
}

#---------------------------------------------------------------
# list_function 
#---------------------------------------------------------------

sub list_function {

    my $msgnum=shift;
    my $ok=shift;
    my $msgfilename=msgfile($msgnum);
    my $here=$DATAPATH?$DATAPATH:'.';

    if (open DAT, "$here/$msgfilename"){
	#do something with the opened message
	$response=$ok?"+OK ":'';
	print $new_sock $response,$msgnum,' ',(stat($msgfilename))[7];
    }
    else {
	print $new_sock "-ERR no such message";
    }
    
}

#---------------------------------------------------------------
# stat_function gives the number of msgxxx.txt messages available
#---------------------------------------------------------------

sub stat_function{
	my @messages=();
 	my $here=$DATAPATH?$DATAPATH:'.';
 	$DATAFNAME=~/^(.*)(\.\w+)$/;
 	my ($prefix,$suffix)=($1,$2);

 	if (opendir DATADIR, $here){
  		@messages = sort grep/^$prefix\d\d\d$suffix$/, readdir DATADIR;
  		closedir DATADIR
	}
	$msgcount=0;
	
	if (@messages) {
  		foreach $message (@messages){
			$msgcount++;
		$octets+=(stat($message))[7];
  		}
	}
	print $new_sock "+OK $msgcount $octets";
#	print "Serving $msgcount files to mail client\n";
}


#---------------------------------------------------------------
# retr_function retrieves message number "n"
#---------------------------------------------------------------

sub retr_function{

	$msgnum=shift;
	my $msgfilename=msgfile($msgnum);
 	my $here=$DATAPATH?$DATAPATH:'.';

	if (open DAT, "$here/$msgfilename"){
		#do something with the opened message (show it? ;)
		print $new_sock "+OK ",(stat($msgfilename))[7]," octets";
		while (<DAT>) {
			chop;
			print $new_sock $_;
		}
		close DAT;
		print $new_sock ".";
	}
	else {
		print $new_sock "-ERR no such message";
	}
}


#---------------------------------------------------------------
# top_function retrieves message number "n"
#---------------------------------------------------------------

sub top_function{

	local ($msgnum,$linez)=@_;
	my $msgfilename=msgfile($msgnum);
 	my $here=$DATAPATH?$DATAPATH:'.';

	$linez+=$hdrsize;
	if (open DAT, "$here/$msgfilename"){
		#do something with the opened message (show it? ;)
		print $new_sock "+OK ",(stat($msgfilename))[7]," octets";
		while (<DAT>) {
			chop;
			print $new_sock $_;
			$linez--;
			last if (!$linez);
		}
		close DAT;
		print $new_sock ".";
	}
	else {
		print $new_sock "-ERR no such message";
	}
}


#---------------------------------------------------
# msgfile returns the filename for message "n"
#---------------------------------------------------
sub msgfile{
	my $msg=shift;
	my $datname=$DATAFNAME;
	$datname=~/(.*)(\.\w+)$/;

	if ($DATAPATH){
		$datname= $DATAPATH.'/'.$1.substr($msg+1000,-3).$2
	}
	else {
 		$datname= $1.substr($msg+1000,-3).$2
	}
}
